<template>
  <v-data-table
    :headers="headers"
    :loading="loading"
    :items="centers"
    :page="page+1"
    :items-per-page="pageSize"
    :server-items-length="total"
    class="elevation-1"
    @click:row="goToDetails"
  >
    <template #item.id="{ item }">
      {{ hashId({ id: item.id }) }}
    </template>
  </v-data-table>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { hashId } from '~/helpers/format/ids';

export default {
  name: 'CentersTable',
  data: () => ({
    loading: false,
    headers: [
      {
        text: 'Nª',
        align: 'start',
        sortable: false,
        value: 'id',
      },
      {
        text: 'Nombre',
        align: 'start',
        sortable: false,
        value: 'name',
      },
      {
        text: 'Dirección',
        sortable: false,
        value: 'address',
      },
    ],
  }),
  computed: {
    ...mapState({
      centers: state => state.company.centers.centers,
      page: state => state.company.centers.pageInfo.page,
      pageSize: state => state.company.centers.pageInfo.pageSize,
      total: state => state.company.centers.pageInfo.total,
    }),
  },
  async mounted() {
    await this.getCentersData();
  },
  methods: {
    hashId,
    ...mapActions({
      getCenters: 'company/centers/getCenters',
    }),
    async getCentersData() {
      this.loading = true;
      try {
        await this.getCenters({});
      } catch (e) {
        console.error(e);
      }
      this.loading = false;
    },
    async goToDetails({ id }) {
      await this.$router.push(`/empresa/centros/${id}`);
    },
  },
};
</script>
